您的位置:首页 > 其它

leetcode note--leetcode 167 Two Sum II - Input array is sorted

2016-12-01 15:56 465 查看


167. Two Sum II - Input array is sorted

Given an array of integers that is already sorted in ascending order, find two numbers such that they add up to a specific target number.
The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2. Please note that your returned answers (both index1 and index2) are not zero-based.
You may assume that each input would have exactly one solution.
Input: numbers={2, 7, 11, 15}, target=9
Output: index1=1, index2=2
解法一:第一想法,效率比较低,用一个hashMap;map里存 key=(target-nums[i]) value=i 这样只要遇到正好的值,取出来就行了

public class Solution {
public int[] twoSum(int[] numbers, int target) {
int[] res = new int[2];
Map<Integer,Integer> map = new HashMap<>();
for(int i = 0;i < numbers.length;i++){
if(map.containsKey(numbers[i])){
res[0] = map.get(numbers[i])+1;
res[1] = i+1;
return res;
}else{
map.put(target-numbers[i],i);
}
}
return res;
}
}
time = 6ms;

方法二:充分利用排序好的特点,直接用两个指针,一前一后,和大于目标,后向前(和减小),和小于目标,前向后(和变大)
public class Solution {
public int[] twoSum(int[] numbers, int target) {
int[] res = new int[2];
for(int i=0,j=numbers.length-1;i<j;){
int ni = numbers[i];
int nj = numbers[j];
if(ni+nj==target){
res[0] = i+1;
res[1] = j+1;
return res;
}else if(ni+nj>target){
j--;
}else{
i++;
}
}
return res;
}
}time = 2ms;
方法三:方法二的改进版:剔除重复元素,也就是当前指针向后或后指针向前时,判断是不是重复元素,把重复元素跳过;

public class Solution {
public int[] twoSum(int[] numbers, int target) {
int[] res = new int[2];
for(int i=0,j=numbers.length-1;i<j;){
int ni = numbers[i];
int nj = numbers[j];
if(ni+nj==target){
res[0] = i+1;
res[1] = j+1;
return res;
}else if(ni+nj>target){
while(i<j && numbers[j]==numbers[j-1]) j--;
j--;
}else{
while(i<j && numbers[i]==numbers[i+1]) i++;//i已经在上边用过了,所以下边要再进行一次,到nums[i]不同的元素上去
i++;
}
}
return res;
}
}
time=1ms;
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  leetcode normal